/*
For debugging only

#include "\RadASM\GoAsm\inc\debug.a"
DBGWIN_DEBUG_ON = 1 ; use this to enable Spy/StopSpy/DbgDump and TrapException
DBGWIN_SHOWONLYERRORS = 1 ; setting this to 1 will suppress PrintError if no error exists
*/

/*
The CONVLIB and STRINGLIB libraries are available on demand from me
just post a request or email me and I will send them to you. Do not
use the equivalent MASM32 functions ! My versions have may have a
different parameter order to more closely follow accepted standards

contact_donkey@hotmail.com 
*/

#IFNDEF CONVLIB
	CONVLIB = C:\RadASM\GoAsm\Projects\Convert\Convert.lib
#ENDIF

#IFNDEF STRINGLIB
	STRINGLIB = C:\RadASM\GoAsm\Projects\Strings\Strings.lib
#ENDIF

dw2a = CONVLIB:dw2ascii
szCopy = STRINGLIB:lszCopy
szCopyn = STRINGLIB:lszCopyn
szLen = STRINGLIB:lszLen
a2dw = CONVLIB:ascii2dw

/*
The program also uses BitmapFromMemory from the MASM32 library, you can
get that at masmforum.com

Also you may want to test the uncompress function on compressed frames, I had no
examples to work with so I did not test it. To do this you will need zlibstat from
LaptoniC, just google for it or ask and I will send it along. You will have to uncomment
the appropriate section in ReadIDtag.
*/

#IFNDEF M32LIB
	M32LIB = C:\MASM32\LIB\MASM32.LIB
#ENDIF

#IFNDEF COMPRESSLIB
	COMPRESSLIB = zlibstat.lib
#ENDIF

SHFILEOPSTRUCT STRUCT
  hwnd                  DD
  wFunc                 DD
  pFrom                 DD
  pTo                   DD
  fFlags                DD
  fAnyOperationsAborted DD
  hNameMappings         DD
  lpszProgressTitle     DD
ENDS

AUDIOHEADER Struct
	cbFile	DD			?		; Size of file in bytes
	BITR	DD			?		; Bitrate of audio
	SMPR	DD			?		; Samplerate of audio
	VBRE	DD			?		; VBR encoded (0 = no, 1 = yes)
	LNTH	DD			?		; Length of track in milliseconds
	MPEG	DD			?		; MPEG encoding type (3 = MPEG1, 2 = MPEG2 , 0 = MPEG2.5)
	LAYR	DD			?		; MPEG layer
	STRT	DD			?		; Start of audio header
	SIZE	DD			?		; Size of audio frame in bytes
	PRIV	DD			?		; Private flag
	CHAN	DD			?		; Channel flag
	PROT	DD			?		; Protection flag
	PAD		DD			?		; Padding flag
	NFRM	DD			?		; Number of frames
	LFRM	DD			?		; Length of frame in milliseconds
	COPR	DD			?		; Copyright Bit
	ORIG	DD			?		; Original Bit
	EMPH	DD			?		; Emphasis
	JSMX	DD			?		; Joint stereo mode extension
ENDS

ID3Info	STRUCT
	cbFile			DD	?
	tagtype			DD	?	; 1 = ID3V1, 3 = ID3V3
	; ID3V1 & ID3V3
	idTIT2			DB	256 DUP (?)	; Title/songname/content description
	idTPE1			DB	256 DUP (?)	; Lead performer(s)/Soloist(s)(Artist)
	idTALB			DB	256 DUP (?)	; Album/Movie/Show title
	idTYER			DB	256 DUP (?)	; Year
	idCOMM			DB	256 DUP (?)	; Comments
	idTRCK			DB	256 DUP (?)	; Track number/Position in set
	idTCON			DB	256 DUP (?)	; Content type
	; ID3V3 Only
	idTCOP			DB	256 DUP (?)	; Copyright message
	idTENC			DB	256 DUP (?)	; Encoder used
	idURL			DB	256 DUP (?)	; URL
	idTCOM			DB	256 DUP (?)	; Composer
	idTOPE			DB	256 DUP (?)	; Original artist(s)/performer(s)
ENDS

V1Tag STRUCT
	cbFile			DD	?
	TAG				DB	"TAG"
	idTIT2			DB	30	DUP (0)
	idTPE1			DB	30	DUP (0)
	idTALB			DB	30	DUP (0)
	idTYER			DB	4	DUP (0)
	idCOMM			DB	29	DUP (0)
	idTRCK			DB	0
	idTCON			DB	0
ENDS

FRAMEHEADER Struct
	Sig		DD	?
	Size	DD	?
	flags	DB	2 DUP (?)
ENDS

V23FILETAG Struct
	sig		DB	"ID3"
	version	DB	03,00
	flags	DB	?
	size	DD	?
ENDS

.const
	id3v4				equ	04334449h
	id3v3				equ	03334449h
	id3v2				equ	02334449h
	Xing				equ	0676E6958h

;	Frame type constants

;	frame_AENC			equ	1129203009
	frame_APIC			equ	1128878145
	frame_COMM			equ	1296912195
;	frame_COMR			equ	1380798275
;	frame_ENCR			equ	1380142661
;	frame_EQUA			equ	1096110405
;	frame_ETCO			equ	1329812549
;	frame_GEOB			equ	1112491335
;	frame_GRID			equ	1145655879
;	frame_IPLS			equ	1397510217
;	frame_LINK			equ	1263421772
;	frame_MCDI			equ	1229210445
;	frame_MLLT			equ	1414286413
;	frame_OWNE			equ	1162762063
;	frame_PRIV			equ	1447645776
;	frame_PCNT			equ	1414415184
;	frame_POPM			equ	1297108816
;	frame_POSS			equ	1397968720
;	frame_RBUF			equ	1179992658
;	frame_RVAD			equ	1145132626
;	frame_RVRB			equ	1112692306
;	frame_SYLT			equ	1414289747
;	frame_SYTC			equ	1129601363
	frame_TALB			equ	1112293716
;	frame_TBPM			equ	1297105492
	frame_TCOM			equ	1297040212
	frame_TCON			equ	1313817428
	frame_TCOP			equ	1347371860
	frame_TDAT			equ	1413563476
	frame_TDLY			equ	1498170452
	frame_TENC			equ	1129203028
	frame_TEXT			equ	1415071060
	frame_TFLT			equ	1414284884
	frame_TIME			equ	1162692948
	frame_TIT1			equ	827607380
	frame_TIT2			equ	844384596
	frame_TIT3			equ	861161812
	frame_TLAN			equ	1312902228
	frame_TLEN			equ	1313164372
	frame_TMED			equ	1145392468
	frame_TOAL			equ	1279348564
	frame_TOFN			equ	1313230676
	frame_TOLY			equ	1498173268
	frame_TOPE			equ	1162891092
	frame_TOWN			equ	1314344788
	frame_TPE1			equ	826626132
	frame_TPE2			equ	843403348
	frame_TPE3			equ	860180564
	frame_TPE4			equ	876957780
	frame_TPOS			equ	1397706836
	frame_TPUB			equ	1112887380
	frame_TRCK			equ	1262703188
	frame_TRDA			equ	1094996564
	frame_TRSN			equ	1314083412
	frame_TRSO			equ	1330860628
	frame_TSIZ			equ	1514754900
	frame_TYER			equ	1380276564
;	frame_TXXX			equ	1482184788
	frame_UFID			equ	1145652821
	frame_USER			equ	1380275029
;	frame_USLT			equ	1414288213
	frame_WCOM			equ	1297040215
	frame_WCOP			equ	1347371863
	frame_WOAF			equ	1178685271
	frame_WOAR			equ	1380011863
	frame_WOAS			equ	1396789079
	frame_WORS			equ	1397903191
	frame_WPAY			equ	1497452631
;	frame_WPUB			equ	1112887383
	frame_WXXX			equ	1482184791


	GENERIC_READ		equ	80000000h
	GENERIC_WRITE		equ	40000000h
	CREATE_NEW			equ	1
	OPEN_EXISTING		equ	3
	PAGE_READONLY		equ 2

	FOF_ALLOWUNDO 		equ	40h
	FOF_NOERRORUI 		equ 400h
	FOF_NOCONFIRMATION	equ 10h
	FOF_SILENT			equ 4h

	FO_MOVE 			equ 1h
	FO_COPY 			equ 2h
	FO_DELETE 			equ 3h
	FO_RENAME 			equ 4h

	FILE_MAP_READ		equ 4

.data
	; Sample rate translation matrix
	V1L1				DD	0,32,64,96,128,160,192,224,256,288,320,352,384,416,448
	V1L2				DD	0,32,48,56,64,80,96,112,128,160,192,224,256,320,384
	V1L3				DD	0,32,40,48,56,64,80,96,112,128,160,192,224,256,320
	V2L1				DD	0,32,48,56,64,80,96,112,128,144,160,176,192,224,256
	V2L2				DD	0,8,16,24,32,40,48,56,64,80,96,112,128,144,160
	V2L3				DD	0,8,16,24,32,40,48,56,64,80,96,112,128,144,160

	flSIZE				DD	?

	pMapFile			DD	?
	hMapFile			DD	?
	hMP3File			DD	?

	NoData				DD	?
	FrameType			DD	?

.code

Start:

/*
Sample calls:

.data
Audhead			AUDIOHEADER	<>
taginfo			ID3Info		<>

.code
invoke GetAudioInfo,"test.mp3",offset Ahead
invoke ReadIDtag,"testcomp.mp3",offset taginfo
invoke ReadV1Tag,"test.mp3",offset taginfo
invoke WriteV23Tag,"test.mp3",offset taginfo,1,0
invoke WriteV1Tag,"test.mp3",offset taginfo,1
invoke ID3GetImage,"test.mp3"
*/

invoke ExitProcess,0

/*
########################################
#	Common functions
########################################
*/

zeromem FRAME pDest,nBytes
	
	mov edx,[nBytes]
	mov ecx,edx
	and edx,3

	shr ecx,2
	xor eax,eax
	mov edi,[pDest]
	rep stosd

	mov ecx,edx
	rep stosb

	RET
ENDF

memcopy FRAME pDest,pSource,nBytes
	uses edi,esi,ecx
	cld
	mov edi,[pDest]
	mov esi,[pSource]
	mov ecx,[nBytes]

	; do the evenly divisible ones
	shr ecx,2
	rep movsd

	; do the remainder
	mov ecx,[nBytes]
	and ecx,3
	rep movsb

	RET
ENDF

FileOp FRAME pszFrom,pszTo,Op,fUndo
	LOCAL sfo		:SHFILEOPSTRUCT
	LOCAL sfoabort	:D

	mov D[sfo.hwnd],0
	mov eax,[Op]
	mov D[sfo.wFunc],eax
	mov eax,[pszFrom]
	mov [sfo.pFrom],eax
	mov eax,[pszTo]

	mov D[sfo.pTo],eax
	mov D[sfo.fFlags],FOF_NOCONFIRMATION + FOF_NOERRORUI + FOF_SILENT
	cmp D[fUndo],1
	jne >
	cmp D[Op],FO_DELETE
	jne >
		or D[sfo.fFlags],FOF_ALLOWUNDO
	:

	mov eax,OFFSET sfoabort
	mov D[sfo.fAnyOperationsAborted],eax
	mov D[sfo.hNameMappings],0
	mov D[sfo.lpszProgressTitle],0
	invoke SHFileOperationA,OFFSET sfo

	RET
ENDF

SynchSafe2dw FRAME ssvar
	uses ecx,edx
	; The following are allocated as DWORDs but used as bytes
	; so that the addresses fall on natural boundaries
	LOCAL	SSCF1	:D
	LOCAL	SSCF2	:D
	LOCAL	SSCF3	:D

/*
Synchsafe integers

	In some parts of the tag it is inconvenient to use the
	unsychronisation scheme because the size of unsynchronised data is
	not known in advance, which is particularly problematic with size
	descriptors. The solution in ID3v2 is to use synchsafe integers, in
	which there can never be any false synchs. Synchsafe integers are
	integers that keep its highest bit (bit 7) zeroed, making seven bits
	out of eight available. Thus a 32 bit synchsafe integer can store 28
	bits of information.

	Example:

		255 (%11111111) encoded as a 16 bit synchsafe integer is 383
		(%00000001 01111111).
*/

	mov eax,[ssvar]

	mov dh,al
	mov dl,ah
	bswap eax
	mov cl,al
	mov ch,ah

	mov al,ch
	mov [SSCF1],al
	and B[SSCF1],1
	shl B[SSCF1],7

	mov al,dl
	mov [SSCF2],al
	and B[SSCF2],3
	shl B[SSCF2],6

	mov al,dh
	mov [SSCF3],al
	and B[SSCF3],7
	shl B[SSCF3],5

;	Build Bytes from data
;
	mov al,[SSCF1]
	or cl,al

	shr ch,1
	mov al,[SSCF2]
	or ch,al

	shr dl,2
	mov al,[SSCF3]
	or dl,al

	shr dh,3

;	Build DWORD from bytes
;
	mov al,cl
	mov ah,ch
	bswap eax
	mov al,dh
	mov ah,dl
	bswap eax

	ret
ENDF

dw2SynchSafe FRAME dwValue
	LOCAL MSB		:D
	LOCAL ssValue	:D

	mov eax,[dwValue]

	; Get the MSB of each byte
	mov [MSB],eax
	and D[MSB],00E0C080h ; 0111000001100000010000000b

	shr B[MSB],7
	shr B[MSB+1],6
	shr B[MSB+2],5
	
	shl D[MSB],8

	mov eax,[dwValue]
	mov [ssValue],eax

	and B[ssValue],7Fh

	shl B[ssValue+1],1
	and B[ssValue+1],7Fh

	shl B[ssValue+2],2
	and B[ssValue+2],7Fh
	
	shl B[ssValue+3],3
	and B[ssValue+3],7Fh

	mov eax,[ssValue]
	or eax,[MSB]

	bswap eax
	RET
ENDF

/*
########################################
#	Audio header
########################################
*/

GetAudioInfo FRAME pFileName,pAudioHeaderStruct
	uses edi, edx

	mov edi,[pAudioHeaderStruct]
	or edi,edi
	jnz >
		xor eax,eax
		dec eax
		ret
	:

	invoke openMP3,[pFileName], [pAudioHeaderStruct]
	dec eax
	jns >
		xor eax,eax
		dec eax
		ret
	:

	invoke GetID3Type
	cmp eax,2
	je >
	cmp eax,3
	je >
	cmp eax,4
	je >
	jmp >I0
	:
		invoke GetTagSize
		mov [edi+AUDIOHEADER.STRT],eax
		jmp >I1
	I0:
		mov D[edi+AUDIOHEADER.STRT],-1
	I1:

	invoke ReadAudioData, [edi+AUDIOHEADER.STRT], edi
	push eax

	.EXIT

	invoke UnmapViewOfFile,[pMapFile]
	invoke CloseHandle,[hMapFile]
	invoke CloseHandle,[hMP3File]

	mov eax,[edi+AUDIOHEADER.LAYR]
	cmp eax,1
	jne >
		mov D[edi+AUDIOHEADER.LAYR],3
		jmp >L1
	:
	cmp eax,3
	jne >L1
		mov D[edi+AUDIOHEADER.LAYR],1
	L1:

	pop eax
	ret

ENDF

openMP3	FRAME pszBUFFER, pID3Info
	uses ebx

	xor ebx,ebx
	invoke CreateFileA,[pszBUFFER],GENERIC_READ,ebx,\
		ebx,OPEN_EXISTING,ebx,ebx

	mov [hMP3File],eax
	invoke CreateFileMappingA,[hMP3File],ebx,PAGE_READONLY,0,0,ebx
	mov [hMapFile],eax
	invoke SetLastError,0
	invoke MapViewOfFile,[hMapFile],FILE_MAP_READ,0,0,0
	mov [pMapFile],eax
	invoke GetLastError
	or eax,eax
	jz >
		invoke CloseHandle,[hMapFile]
		invoke CloseHandle,[hMP3File]
		xor eax,eax
		dec eax
		ret
	:
	invoke GetFileSize,[hMP3File],ebx
	mov ebx,[pID3Info]
	mov [ebx],eax ; First member of every structure must be cbFile !!!
	mov eax,[hMP3File]
	ret
ENDF

ID1Size FRAME pFileOffset,dwFileSize
	LOCAL tester[16]	:B

	mov eax,[pFileOffset]
	add eax,[dwFileSize]
	sub eax,128
	mov eax,[eax]
	and eax,0FFFFFFh
	cmp eax,"TAG"
	jne >
	mov eax,128
	ret
	:
	mov eax,0
	RET
ENDF

GetID3Type:
	uses edi, edx
	mov edi,[pMapFile]

	mov eax,[edi]

		cmp eax,id3v4
		jne >
		mov eax,4
		jmp >.EXIT

	:
		cmp eax,id3v3
		jne >
		mov eax,3
		jmp >.EXIT

	:
		cmp eax,id3v2
		jne >
		mov eax,2
		jmp >.EXIT

	:
		mov eax,0

	.EXIT

	ret
ENDU

GetTagSize:
	uses edi, edx
	mov edi,[pMapFile]
	add edi,6
	mov eax,[edi]
	invoke SynchSafe2dw,eax
	ret
ENDU

DecodeAudioData FRAME pID3Info
	uses edi, edx , ebx
	LOCAL	ahData1			:D	; Holder for audio header DWORD
	LOCAL	ahData2			:D	; Holder for audio header DWORD
	LOCAL	ahData3			:D	; Holder for audio header DWORD

	mov ebx,[pID3Info]

	mov edi,[pMapFile]
	add edi,[ebx+AUDIOHEADER.STRT] ;[BaseAddr]
	xor eax,eax
	mov al,[edi + 1]
	mov [ahData1],eax

	xor eax,eax
	mov al,[edi + 2]
	mov [ahData2],eax

	xor eax,eax
	mov al,[edi + 3]
	mov [ahData3],eax

	mov eax,[ahData1]
	and eax,24
	shr eax,3
	mov [ebx+AUDIOHEADER.MPEG],eax

	mov eax,[ahData1]
	and eax,6
	shr eax,1
	mov [ebx+AUDIOHEADER.LAYR],eax

	mov eax,[ahData1]
	and eax,1
	mov [ebx+AUDIOHEADER.PROT],eax

	mov eax,[ahData2]
	and eax,240
	shr eax,4
	mov [ebx+AUDIOHEADER.BITR],eax

	mov eax,[ahData2]
	and eax,12
	shr eax,2
	mov [ebx+AUDIOHEADER.SMPR],eax

	mov eax,[ahData2]
	and eax,2
	shr eax,1
	mov [ebx+AUDIOHEADER.PAD],eax

	mov eax,[ahData2]
	and eax,1
	mov [ebx+AUDIOHEADER.PRIV],eax

	mov eax,[ahData3]
	and eax,192
	shr eax,6
	mov [ebx+AUDIOHEADER.CHAN],eax

	mov eax,[ahData3]
	and eax,48
	shr eax,4
	mov [ebx+AUDIOHEADER.JSMX],eax

	mov eax,[ahData3]
	and eax,8
	shr eax,3
	mov [ebx+AUDIOHEADER.COPR],eax

	mov eax,[ahData3]
	and eax,4
	shr eax,2
	mov [ebx+AUDIOHEADER.ORIG],eax

	mov eax,[ahData3]
	and eax,3
	mov [ebx+AUDIOHEADER.EMPH],eax

	ret
ENDF

DecodeRateData FRAME pID3Info
	uses edi, edx, ecx, ebx
	LOCAL	BitRate	 	:D
	LOCAL	SampleRate	:D
	LOCAL	Padding		:D

	mov ebx,[pID3Info]

	shl D[ebx+AUDIOHEADER.BITR],2

	cmp D[ebx+AUDIOHEADER.MPEG],3
	je >.MPEG1
	cmp D[ebx+AUDIOHEADER.MPEG],2
	je >>.MPEG2
	cmp D[ebx+AUDIOHEADER.MPEG],0
	je >>.MPEG25
	
	jmp >>.UNKNOWN

	.MPEG1
		cmp D[ebx+AUDIOHEADER.LAYR],1
		jne >
			mov eax,[ebx+AUDIOHEADER.BITR]
			mov eax,[V1L3+eax]
			mov [BitRate], eax
			jmp >I1
		:
		cmp D[ebx+AUDIOHEADER.LAYR],2
		jne >
			mov eax,[ebx+AUDIOHEADER.BITR]
			mov eax,[V1L2+eax]
			mov [BitRate], eax
			jmp >I1
		:
		cmp D[ebx+AUDIOHEADER.LAYR],3
		jne >
			mov eax,[ebx+AUDIOHEADER.BITR]
			mov eax,[V1L1+eax]
			mov [BitRate], eax
			jmp >I1
		:
			mov D[BitRate], 0
		I1:

		cmp D[ebx+AUDIOHEADER.SMPR],0
		jne >
			mov D[SampleRate],44100
			jmp >I2
		:
		cmp D[ebx+AUDIOHEADER.SMPR],2
		jne >
			mov D[SampleRate],48000
			jmp >I2
		:
		cmp D[ebx+AUDIOHEADER.SMPR],4
		jne >
			mov D[SampleRate],32000
			jmp >I2
		:
			mov D[SampleRate],0
		I2:
		jmp >>.DONE

	.MPEG2
		cmp D[ebx+AUDIOHEADER.LAYR],1
		jne >
			mov eax,[ebx+AUDIOHEADER.BITR]
			mov eax,[V2L3+eax]
			mov [BitRate], eax
			jmp >I1
		:
		cmp D[ebx+AUDIOHEADER.LAYR],2
		jne >
			mov eax,[ebx+AUDIOHEADER.BITR]
			mov eax,[V2L2+eax]
			mov [BitRate], eax
			jmp >I1
		:
		cmp D[ebx+AUDIOHEADER.LAYR],3
		jne >
			mov eax,[ebx+AUDIOHEADER.BITR]
			mov eax,[V2L1+eax]
			mov [BitRate], eax
			jmp >I1
		:
			mov D[BitRate], 0
		I1:

		cmp D[ebx+AUDIOHEADER.SMPR],0
		jne >
			mov D[SampleRate],22050
			jmp >I2
		:
		cmp D[ebx+AUDIOHEADER.SMPR],2
		jne >
			mov D[SampleRate],24000
			jmp >I2
		:
		cmp D[ebx+AUDIOHEADER.SMPR],4
		jne >
			mov D[SampleRate],16000
			jmp >I2
		:
			mov D[SampleRate],0
		I2:
		jmp >>.DONE


	.MPEG25
		cmp D[ebx+AUDIOHEADER.LAYR],1
		jne >
			mov eax,[ebx+AUDIOHEADER.BITR]
			mov eax,[V2L3+eax]
			mov [BitRate], eax
			jmp >I1
		:
		cmp D[ebx+AUDIOHEADER.LAYR],2
		jne >
			mov eax,[ebx+AUDIOHEADER.BITR]
			mov eax,[V2L2+eax]
			mov [BitRate], eax
			jmp >I1
		:
		cmp D[ebx+AUDIOHEADER.LAYR],3
		jne >
			mov eax,[ebx+AUDIOHEADER.BITR]
			mov eax,[V2L1+eax]
			mov [BitRate], eax
			jmp >I1
		:
			mov D[BitRate], 0
		I1:

		cmp D[ebx+AUDIOHEADER.SMPR],0
		jne >
			mov D[SampleRate],11025
			jmp >I2
		:
		cmp D[ebx+AUDIOHEADER.SMPR],2
		jne >
			mov D[SampleRate],12000
			jmp >I2
		:
		cmp D[ebx+AUDIOHEADER.SMPR],4
		jne >
			mov D[SampleRate],8000
			jmp >I2
		:
			mov D[SampleRate],0
		I2:
		jmp >.DONE

	.UNKNOWN
		mov D[SampleRate],0
		mov D[BitRate],0

	.DONE

	mov eax,[BitRate]
	mov ecx,1000
	mul ecx
	mov [ebx+AUDIOHEADER.BITR],eax

	mov eax,[SampleRate]
	mov [ebx+AUDIOHEADER.SMPR],eax

; Get file size
;
	invoke ID1Size,[pMapFile],[ebx+AUDIOHEADER.cbFile]
	mov ecx,eax
	mov eax,[ebx+AUDIOHEADER.cbFile]
	sub eax,[ebx+AUDIOHEADER.STRT]
	sub eax,ecx ; subtract the ID1 tag if any
	mov [flSIZE],eax

	cmp D[ebx+AUDIOHEADER.LAYR],3
	jne >
		mov eax,4
		mul D[ebx+AUDIOHEADER.PAD]
		mov [Padding],eax

		mov eax,[ebx+AUDIOHEADER.BITR]
		mov ecx,12
		mul ecx
		div D[ebx+AUDIOHEADER.SMPR]
		mov [ebx+AUDIOHEADER.SIZE],eax
		mov edx,0
		div D[ebx+AUDIOHEADER.SMPR]

		mov eax,[ebx+AUDIOHEADER.SIZE]
		shl eax,2
		add eax,[Padding]
		mov [ebx+AUDIOHEADER.SIZE],eax

		mov eax,384
		jmp >L1
	:
		mov eax,[ebx+AUDIOHEADER.PAD]
		mov [Padding],eax

		mov eax,[ebx+AUDIOHEADER.BITR]
		mov ecx,144
		mul ecx
		div D[ebx+AUDIOHEADER.SMPR]
		add eax,[Padding]
		mov [ebx+AUDIOHEADER.SIZE],eax

		mov eax,1152
	L1:

	mov ecx,1000
	mul ecx
	div D[ebx+AUDIOHEADER.SMPR]
	mov [ebx+AUDIOHEADER.LFRM],eax

	mov eax,[flSIZE]
	mov edx,0
	div D[ebx+AUDIOHEADER.SIZE]
	mov [ebx+AUDIOHEADER.NFRM],eax

	mov eax,[ebx+AUDIOHEADER.NFRM]
	mul D[ebx+AUDIOHEADER.LFRM]
	mov [ebx+AUDIOHEADER.LNTH],eax

	ret
ENDF

CheckVBR FRAME pID3Info
	uses edi, edx, ebx
	
	mov ebx,[pID3Info]

	mov edi,[pMapFile]
	add edi,[ebx+AUDIOHEADER.STRT]
	mov eax,[edi+36]
	cmp eax, Xing
	jne >
		mov D[ebx+AUDIOHEADER.VBRE],1
		ret
	:
		mov D[ebx+AUDIOHEADER.VBRE],0
		ret
ENDF

DecodeVBR FRAME pID3Info
	uses edi, edx, ecx, ebx
	
	mov ebx,[pID3Info]

	mov edi,[pMapFile]
	add edi,[ebx+AUDIOHEADER.STRT]
	mov eax,[edi+44]
	bswap eax	; convert to big endian format
	mov [ebx+AUDIOHEADER.NFRM],eax

	mov eax,1152000
	mul D[ebx+AUDIOHEADER.NFRM]
	div D[ebx+AUDIOHEADER.SMPR]
	mov [ebx+AUDIOHEADER.LNTH],eax

	mov eax,[flSIZE]
	mov edx,0
	div D[ebx+AUDIOHEADER.NFRM]
	mov [ebx+AUDIOHEADER.LFRM],eax

	mov eax,[ebx+AUDIOHEADER.PAD]
	add [ebx+AUDIOHEADER.LFRM],eax
	mov eax,[ebx+AUDIOHEADER.SMPR]
	mul D[ebx+AUDIOHEADER.LFRM]
	mov ecx,144
	div ecx
	mov [ebx+AUDIOHEADER.BITR],eax
	ret
ENDF

ReadAudioData FRAME FilePointer, pID3Info
	uses edi, edx , ebx
	LOCAL	ahByte1			:B
	LOCAL	ahByte2			:B
	LOCAL	ahByte3			:B
	LOCAL	MaxRead			:D

	mov ebx,[pID3Info]

	mov eax,[ebx+AUDIOHEADER.cbFile]
	mov [MaxRead],eax

	cmp D[MaxRead],32768
	jl >
		mov D[MaxRead],32768
	:

	mov edi,[pMapFile]
	add edi,[FilePointer]

	.scanfile:
		inc edi
		mov eax,edi
		sub eax,[pMapFile]
		cmp eax,[MaxRead]
		jae >.noheader

		mov al,[edi]
		cmp al,255
		jne .scanfile
		mov [ahByte1],al

		mov eax,edi
		sub eax,[pMapFile]
		mov [ebx+AUDIOHEADER.STRT],eax

		inc edi
		mov al,[edi]
		cmp al,240
		jbe .scanfile

		mov [ahByte1],al

		xor eax,eax
		inc edi
		mov al,[edi]
		mov [ahByte2],al
		xor eax,eax
		inc edi
		mov al,[edi]
		mov [ahByte3],al
		dec edi
		dec edi
		dec edi
		cmp B[ahByte2],240
		jae .scanfile
		jmp >.goodsynch

	.noheader:
		invoke zeromem,ebx,SIZEOF AUDIOHEADER
		xor eax,eax
		dec eax
		ret

	.goodsynch:
		invoke CheckVBR, [pID3Info]
		invoke DecodeAudioData,[pID3Info]
		invoke DecodeRateData,[pID3Info]
		cmp D[ebx+AUDIOHEADER.VBRE],1
		jne >
			invoke DecodeVBR, [pID3Info]
		:
		xor eax,eax
		inc eax
		ret
endf

/*
########################################
#	V1.1 TAGS
########################################
*/

ReadIDV1tag FRAME pInfoStruct
	uses edi, edx, ecx, esi
	LOCAL DataBuffer[16]	:B
	LOCAL hModule			:D

	invoke GetModuleHandleA,0
	mov [hModule],eax

	mov esi,[pInfoStruct] ; ID3Info
	mov eax,esi
	add eax,8
	invoke zeromem,eax,SIZEOF ID3Info - 8

	mov eax,[esi]
	cmp eax,128
	ja >
		xor eax,eax
		ret
	:
	sub eax,128
	mov edi,[pMapFile]
	add edi,eax
	xor eax,eax
	; Recheck this thing, it's dumb
	mov eax,[edi]
	and eax,0FFFFFFh
	cmp eax,"TAG"
	jne >>
		
		add edi,3
		lea eax,[esi+ID3Info.idTIT2]
		invoke szCopyn,eax,edi,30
		add edi,30

		lea eax,[esi+ID3Info.idTPE1]
		invoke szCopyn,eax,edi,30
		add edi,30

		lea eax,[esi+ID3Info.idTALB]
		invoke szCopyn,eax,edi,30
		add edi,30

		lea eax,[esi+ID3Info.idTYER]
		invoke szCopyn,eax,edi,4
		add edi,4

		lea eax,[esi+ID3Info.idCOMM]
		invoke szCopyn,eax,edi,29
		add edi,29

		movzx eax,B[edi]
		lea ecx,[esi+ID3Info.idTRCK]
		invoke dw2a,eax,ecx
		add edi,1

		movzx ebx,B[edi]
		lea edi,[esi+ID3Info.idTCON]
		invoke dw2a,ebx,edi
		invoke szLen,edi
		add eax,edi
		mov B[eax]," "
		inc eax
		add ebx,2000
		invoke LoadStringA,[hModule],ebx,eax,256

;		invoke dw2a,eax,ADDR DataBuffer
;		lea eax,[esi+ID3Info.idTCON]
;		invoke szCopyn,eax,ADDR DataBuffer,3

		xor eax,eax
		ret

	:
		xor eax,eax
		dec eax
		ret

ENDF

ReadV1Tag FRAME pFileName,pID3Info
	uses edi

	mov edi, [pID3Info]
	or edi,edi
	jnz >
		xor eax,eax
		dec eax
		ret
	:

	invoke openMP3,[pFileName],[pID3Info]
	dec eax
	jns >
		xor eax,eax
		dec eax
		ret
	:

	invoke ReadIDV1tag,[pID3Info]
	push eax

	invoke UnmapViewOfFile,[pMapFile]
	invoke CloseHandle,[hMapFile]
	invoke CloseHandle,[hMP3File]

	pop eax
	or eax,eax
	jnz >
		mov D[edi+ID3Info.tagtype],1
		xor eax,eax
		ret
	:
		xor eax,eax
		dec eax
		ret

ENDF

WriteV1Tag FRAME pFileName,pID3Info,fAllowUndo
	uses edi,ebx,esi
	LOCAL outframe		:V1Tag
	LOCAL fRemove		:D
	LOCAL fExists		:D
	LOCAL pBuffer		:D
	LOCAL hTmpFile		:D
	LOCAL cbWritten		:D
	LOCAL TmpFile[260]	:B
	LOCAL DestPath[260]	:B
	LOCAL DestFile[64]	:B

	invoke zeromem,offset outframe,SIZEOF V1Tag
	invoke zeromem,offset DestPath,260
	invoke zeromem,offset TmpFile,260

	mov D[fRemove],0

	mov edi, [pID3Info]
	or edi,edi
	jnz >
		mov D[fRemove],1
		mov edi, offset outframe
	:

	invoke openMP3,[pFileName],edi
	dec eax
	jns >
		xor eax,eax
		dec eax
		ret
	:

	mov ebx,[edi]

	mov D[fExists],1
	; Is there an existing tag ?
	invoke ID1Size,[pMapFile],ebx
	or eax,eax
	jnz >
		mov D[fExists],0
	:
	sub ebx,eax


	invoke GetTempPathA,260,offset TmpFile
	invoke GetTempFileNameA,offset TmpFile,"zm_",0,offset TmpFile
	or eax,eax
	jz >>.ERRORNOHANDLE

	invoke DeleteFileA,offset TmpFile

	invoke CreateFileA,offset TmpFile,GENERIC_WRITE,0,0,CREATE_NEW,0,0
	mov [hTmpFile],eax
	or eax,eax
	js >>.ERRORNOHANDLE

	invoke SetLastError,0

	invoke WriteFile,[hTmpFile],[pMapFile],ebx,offset cbWritten,0

	; We are done with file mapping so close it
	invoke UnmapViewOfFile,[pMapFile]
	invoke CloseHandle,[hMapFile]
	invoke CloseHandle,[hMP3File]

	cmp D[fRemove],1
	je >>.EXIT
		invoke szCopy,offset outframe.TAG,"TAG"

		lea eax,[edi+ID3Info.idTIT2]
		invoke szCopyn,offset outframe.idTIT2,eax,30

		lea eax,[edi+ID3Info.idTPE1]
		invoke szCopyn,offset outframe.idTPE1,eax,30

		lea eax,[edi+ID3Info.idTALB]
		invoke szCopyn,offset outframe.idTALB,eax,30

		lea eax,[edi+ID3Info.idTYER]
		invoke szCopyn,offset outframe.idTYER,eax,4

		lea eax,[edi+ID3Info.idCOMM]
		invoke szCopyn,offset outframe.idCOMM,eax,29

		lea eax,[edi+ID3Info.idTRCK]
		invoke a2dw,eax
		mov ebx,offset outframe.idTRCK
		mov B[ebx],al

		lea edi,[edi+ID3Info.idTCON]
		mov esi,edi
		invoke szLen,edi
		mov ecx,eax
		or eax,eax
		jz >
			mov al," "
			repne scasb
			mov B[edi],0
			invoke a2dw,esi
			mov edi,offset outframe.idTCON
			mov B[edi],al
		:

		invoke WriteFile,[hTmpFile],offset outframe.TAG,128,offset cbWritten,0
		invoke FlushFileBuffers,[hTmpFile]
		
	.EXIT
	invoke CloseHandle,[hTmpFile]
	
	invoke GetLastError
	or eax,eax
	jnz >.ERROR
	; The file was created without errors
	; So delete the original and move the tempfile in it's place

	; We need the fully qualified path the the destination
	invoke GetFullPathNameA,[pFileName],260,offset DestPath,offset DestFile
	invoke GetLongPathNameA,offset DestPath,offset DestPath,260

	invoke FileOp,offset DestPath,0,FO_DELETE,[fAllowUndo]
	or eax,eax
	jnz >.ERROR
	invoke FileOp,offset TmpFile,offset DestPath,FO_MOVE,0

	ret
	.ERROR
	invoke DeleteFileA,offset TmpFile
	xor eax,eax
	dec eax
	ret

	.ERRORNOHANDLE
	xor eax,eax
	dec eax
	ret

ENDF

/*
########################################
#	V2.3 TAGS
########################################
*/

BuildContentString FRAME pContent,pOutput
	uses esi,edi,ebx
	LOCAL hModule			:D
	LOCAL TmpBuffer[256]	:B

	invoke GetModuleHandleA,0
	mov [hModule],eax

	invoke szCopy,offset TmpBuffer,[pContent]

	; Strip the content #
	mov edi,offset TmpBuffer
	mov esi,edi
	mov al,[edi]
	cmp al,"0"
	jl >
	cmp al,"9"
	jg >
	jmp >L1
	:
		inc edi
		inc esi
	L1:
	invoke szLen,edi
	jz >.ERROR
	mov ecx,eax

	:
	mov al,[edi]
	cmp al,"0"
	jl >
	cmp al,"9"
	jg >
	inc edi
	jmp <
	:
	mov B[edi],0

	invoke szCopy,[pOutput],esi
	invoke a2dw,[pOutput]
	mov ebx,eax
	add ebx,2000

	invoke szLen,[pOutput]
	mov edi,eax
	add edi,[pOutput]
	mov B[edi]," "
	inc edi

	invoke LoadStringA,[hModule],ebx,edi,256
	or eax,eax
	jnz >.EXIT

	.ERROR
	invoke szCopy,[pOutput],[pContent]

	.EXIT
	RET
ENDF

ReadIDtag FRAME xpFileName,pID3Info
	uses edi, edx, esi
	LOCAL	TagType			:D
	LOCAL	cbTag			:D
	LOCAL	cbFrame			:D
	LOCAL	TopOfFrame		:D
	LOCAL	NextFrame		:D
	LOCAL	cbData			:D
	LOCAL	charFrame		:D
	LOCAL	ReturnValue		:D
	LOCAL	Encrypt			:D
	LOCAL	Compress		:D
	LOCAL	TagBuffer[256]	:B
	LOCAL	pcmpBuffer		:D
	LOCAL	cbDest			:D

	mov D[cbDest],1024
;	Calculate structure offsets
;
	mov esi, [pID3Info]
	or esi,esi
	jnz >
		mov eax,-1
		ret
	:

	invoke zeromem,esi, SIZEOF ID3Info
 
	invoke openMP3,[xpFileName],esi
	dec eax
	jns >
		mov eax,-1
		ret
	:

	mov edi,offset TagBuffer

;	The main read loop
;
	invoke GetID3Type
	mov [TagType],eax

	cmp D[TagType],3
	je >
	cmp D[TagType],4
	je >
	jmp >>.ID1TAG
	:
		invoke GetTagSize
		mov [cbTag],eax
		mov D[TopOfFrame],10

		jmp >>W2
		W1:
			invoke GetFrameType,[TopOfFrame]
			mov [FrameType],eax
			invoke GetNextFramePos,[TopOfFrame]
			mov [NextFrame],eax
			sub eax,10
			mov [cbFrame],eax

			cmp D[NoData],0
			jne >>.NODATA
				invoke GetFrameCharType,[TopOfFrame]
				mov [charFrame],eax
				invoke GetFrameCompression,[TopOfFrame]
				mov [Compress],eax
				invoke GetFrameEncryption,[TopOfFrame]
				mov [Encrypt],eax


				cmp D[Compress], 128
				je >.compressed
				cmp D[Encrypt], 64
				je >>.encrypt

					invoke ReadV3Frame,[TopOfFrame],[cbFrame],edi,[NextFrame],[charFrame]
					mov [cbData],eax
					jmp >>.SetStructure

				.compressed
					 ;invoke szCopy,edi,"Frame is compressed"

					/*
					Decompress frame

					I can't test this as I have no tags with compression handy
					If it doesn't work uncomment the szCopy line and delete everything
					up to jmp >.SetStructure. The most likely reason it doesn't work is
					that the source size is wrong. That is held in EAX on calling uncompress

					Removing this little block of code saves roughly 17,408 bytes
					*/

					; If you do not have the zlibstat library ask me and I will send it

					mov eax,[NextFrame]
					sub eax,[TopOfFrame]
					mov ecx,[TopOfFrame]
					add ecx,[pMapFile]
					invoke memcopy,edi,ecx,eax

					mov eax,edi
					add eax,10
					mov eax,[eax]
					invoke SynchSafe2dw,eax
					push eax

					mov [cbDest],eax
					add D[cbDest],4096
					and D[cbDest],-4095
					invoke GlobalAlloc,040h,[cbDest]
					mov [pcmpBuffer],eax

					pop eax
					mov ecx,edi
					add ecx,14
					invoke COMPRESSLIB:uncompress,[pcmpBuffer],offset cbDest,ecx,eax

					mov eax,[pcmpBuffer]
					mov edx,eax
					add edx,[cbDest]
					xor ecx,ecx
					L1:
						mov cl,[eax]
						cmp cl,0
						jne >
							mov B[eax]," "
						:
						inc eax
						cmp eax,edx
						jl <L1

					invoke szCopyn,edi,[pcmpBuffer],255
					invoke GlobalFree,[pcmpBuffer]
					mov eax,[cbDest]
					mov [cbData],eax
					jmp >.SetStructure

				.encrypt
					invoke szCopy,edi,"Frame is encrypted"

				.SetStructure

				cmp D[cbData], 255
				jl >
					mov D[cbData],255
				:

				mov eax,[FrameType]
				cmp eax,frame_TIT2
				jne >
					lea eax,[esi+ID3Info.idTIT2]
					invoke szCopy,eax,edi
					jmp >>.NODATA
				:
				cmp eax,frame_TALB
				jne >
					lea eax,[esi+ID3Info.idTALB]
					invoke szCopy,eax,edi
					jmp >>.NODATA
				:
				cmp eax,frame_COMM
				jne >
					lea eax,[esi+ID3Info.idCOMM]
					invoke szCopy,eax,edi
					jmp >>.NODATA
				:
				cmp eax,frame_TPE1
				jne >
					lea eax,[esi+ID3Info.idTPE1]
					invoke szCopy,eax,edi
					jmp >>.NODATA
				:
				cmp eax,frame_TCON
				jne >
					lea eax,[esi+ID3Info.idTCON]
					invoke BuildContentString,edi,eax
					jmp >>.NODATA
				:
				cmp eax,frame_TRCK
				jne >
					lea eax,[esi+ID3Info.idTRCK]
					invoke szCopy,eax,edi
					jmp >>.NODATA
				:
				cmp eax,frame_TYER
				jne >
					lea eax,[esi+ID3Info.idTYER]
					invoke szCopy,eax,edi
					jmp >>.NODATA
				:
				cmp eax,frame_TCOP
				jne >
					lea eax,[esi+ID3Info.idTCOP]
					invoke szCopy,eax,edi
					jmp >>.NODATA
				:
				cmp eax,frame_TENC
				jne >
					lea eax,[esi+ID3Info.idTENC]
					invoke szCopy,eax,edi
					jmp >>.NODATA
				:
				cmp eax,frame_WXXX
				jne >
					lea eax,[esi+ID3Info.idURL]
					invoke szCopy,eax,edi
					jmp >>.NODATA
				:
				cmp eax,frame_TCOM
				jne >
					lea eax,[esi+ID3Info.idTCOM]
					invoke szCopy,eax,edi
					jmp >>.NODATA
				:
				cmp eax,frame_TOPE
				jne >
					lea eax,[esi+ID3Info.idTOPE]
					invoke szCopy,eax,edi
					jmp >>.NODATA
				:
			.NODATA

			mov eax,[NextFrame]
			cmp eax, [TopOfFrame]
			je >
				mov [TopOfFrame],eax
				jmp >W2
			:
				mov eax, [cbTag]
				inc eax

		W2:
		cmp eax, [cbTag] 
		jle <<W1

		mov eax, [TagType]
		mov [ReturnValue] ,eax
		mov D[esi+ID3Info.tagtype],3
		jmp >.DONE

	.ID1TAG
	cmp D[TagType],0
	jne >.DONE
		invoke ReadIDV1tag, esi ;[pID3Info]
		or eax,eax
		jnz >
			mov D[esi+ID3Info.tagtype],1
			mov D[ReturnValue],1
			jmp >.DONE
		:
			mov D[ReturnValue],0

	.DONE

;	End of main read loop
;
;	Close the file now that we're done

	invoke UnmapViewOfFile,[pMapFile]
	invoke CloseHandle,[hMapFile]
	invoke CloseHandle,[hMP3File]

;	If this was an ID3V2.2 tag return the tag type and that's all
;
	cmp D[TagType],2
	je >
	cmp D[TagType],4
	je >
	jmp >.EXIT
	:
		mov eax, [TagType]
		mov [esi+ID3Info.tagtype],eax
		ret
	.EXIT

	mov eax,[ReturnValue]
	ret
ENDF

ID3GetImage FRAME pFileName
	uses edi, edx, esi
	LOCAL	TagType			:D
	LOCAL	cbTag			:D
	LOCAL	cbFrame			:D
	LOCAL	TopOfFrame		:D
	LOCAL	NextFrame		:D
	LOCAL	ReturnValue		:D
	LOCAL	cbFile			:D

	invoke openMP3,[pFileName],offset cbFile
	dec eax
	jns >
		mov eax,-1
		ret
	:

	mov D[ReturnValue],0

	invoke GetID3Type
	mov [TagType],eax

	cmp D[TagType],3
	je >
	cmp D[TagType],4
	je >
	jmp >>.EXIT
	:
		invoke GetTagSize
		mov [cbTag],eax
		mov D[TopOfFrame],10

		jmp >>W2
		W1:
			invoke GetFrameType,[TopOfFrame]
			mov [FrameType],eax
			invoke GetNextFramePos,[TopOfFrame]
			mov [NextFrame],eax
			sub eax,10
			mov [cbFrame],eax

			cmp D[NoData],0
			jne >.NODATA
				mov eax,[FrameType]
				cmp eax,frame_APIC
				jne >.NODATA
					mov edi,[TopOfFrame]
					add edi,11
					add edi,[pMapFile]

					mov eax,edi
					add eax,[cbFrame]
					mov [NextFrame],eax


					:
					mov al,[edi]
					inc edi
					cmp edi,[NextFrame]
					jae >.NODATA
					cmp al,0
					jne <
					inc edi
					:
					mov al,[edi]
					inc edi
					cmp edi,[NextFrame]
					jae >.NODATA
					cmp al,0
					jne <

					invoke M32LIB:BitmapFromMemory,edi,[cbFrame]

					mov [ReturnValue],eax
					jmp >>.EXIT
				:
			.NODATA

			mov eax,[NextFrame]
			cmp eax, [TopOfFrame]
			je >
				mov [TopOfFrame],eax
				jmp >W2
			:
				mov eax, [cbTag]
				inc eax

		W2:
		cmp eax, [cbTag] 
		jle <<W1

;	Close the file now that we're done

	.EXIT
	invoke UnmapViewOfFile,[pMapFile]
	invoke CloseHandle,[hMapFile]
	invoke CloseHandle,[hMP3File]

	mov eax,[ReturnValue]

	ret
ENDF

GetFrameType FRAME FrameStart
	uses edi, edx
	mov edx,[FrameStart]
	mov edi,[pMapFile]
	mov eax,[edi+edx]
	ret
ENDF

GetNextFramePos FRAME FrameStart
	uses edi, edx

	mov edi,[pMapFile]
	mov edx,[FrameStart]
	mov eax,[edi+edx+4]
	bswap eax

	mov D[NoData],0
	cmp D[FrameType],frame_COMM
	je >.EXIT
	cmp eax,1
	jne >
		mov D[NoData],1
		jmp >.EXIT
	:
	cmp eax,3
	jne >.EXIT
		mov D[NoData],1

	.EXIT
	add eax,10
	add eax,[FrameStart]
	ret
ENDF

GetFrameCharType FRAME FrameStart
	uses edi, edx
	xor eax,eax
	mov edi,[pMapFile]
	mov edx,[FrameStart]
	mov al,[edi+edx+10]
	ret
ENDF

GetFrameCompression FRAME FrameStart
	uses edi, edx

	xor eax,eax
	mov edi,[pMapFile]
	mov edx,[FrameStart]
	mov al,[edi+edx+9]
	and eax,128
	ret
ENDF

GetFrameEncryption FRAME FrameStart
	uses edi, edx
	xor eax,eax
	mov edi,[pMapFile]
	mov edx,[FrameStart]
	mov al,[edi+edx+9]
	and eax,64
	ret
ENDF

ReadV3Frame FRAME FrameStart,FrameSize,BufferAddr,NextFrame,DataType
	uses edi, ecx, ebx, esi
	LOCAL	DataBuffer[256]		:B
	LOCAL	UDataBuffer[256]	:W

	cmp D[NoData],1
	jne >
		mov edi,[BufferAddr]
		xor eax,eax
		mov [edi],eax
		inc eax
		ret
	:

	mov esi,[NextFrame]
	dec esi

	mov eax,[FrameStart]
	add eax,11

	mov edi,eax
	add edi,[pMapFile]
	xor ecx,ecx
	xor eax,eax
	xor ebx,ebx

	cmp D[DataType],0
	jne >>D2
		jmp >W2
		W1:
			xor eax,eax
			mov al,[edi]
			or eax,eax
			jnz >
				xor ebx,ebx
			:
			cmp eax,1Fh
			jle >E1
			cmp eax,7Fh
			jge >E1
			cmp ebx,256
			jge >E1
				mov [DataBuffer+ebx],al
				inc ebx
			E1:
			inc edi
			mov eax,edi
			sub eax,[pMapFile]
		W2:
		cmp eax,esi
		jle <W1
		jmp >>D3

	D2:
		jmp >W4
		W3:
			xor eax,eax
			mov ax,[edi]
			add edi,2
			or eax,eax
			jnz >
			cmp edi,esi
			jge >
				xor ebx,ebx
			:
			cmp eax,1Fh
			jle >E2
			cmp eax,7Fh
			jge >E2
			cmp ebx,512
			jge >E2
				mov [UDataBuffer+ebx],ax
				add ebx,2
			E2:
			mov eax,edi
			sub eax,[pMapFile]
		W4:
		cmp eax,esi
		jle <W3
	D3:

	cmp D[DataType],0
	je >
		shr ebx, 1
		invoke WideCharToMultiByte,0,0,offset UDataBuffer,ebx,offset DataBuffer,256,0,0
		mov ebx,eax
	:

	mov B[DataBuffer+ebx],0
	inc ebx
	invoke memcopy,[BufferAddr],ADDR DataBuffer,ebx

	mov eax,ebx
	ret
ENDF

ID3GetFrameByIndex FRAME pFileName,dwIndex,pBuffer
	uses edi, edx, esi
	LOCAL	TagType			:D
	LOCAL	cbTag			:D
	LOCAL	cbFrame			:D
	LOCAL	TopOfFrame		:D
	LOCAL	NextFrame		:D
	LOCAL	ReturnValue		:D
	LOCAL	cbFile			:D
	LOCAL	framecount		:D

	mov D[framecount],0

	invoke openMP3,[pFileName],offset cbFile
	dec eax
	jns >
		mov eax,-1
		ret
	:

	mov D[ReturnValue],0

	invoke GetID3Type
	mov [TagType],eax

	cmp D[TagType],3
	je >
	cmp D[TagType],4
	je >
	jmp >>.EXIT
	:
		invoke GetTagSize
		mov [cbTag],eax
		mov D[TopOfFrame],10

		jmp >>W2
		W1:
			invoke GetFrameType,[TopOfFrame]
			mov [FrameType],eax
			invoke GetNextFramePos,[TopOfFrame]
			mov [NextFrame],eax
			sub eax,10
			mov [cbFrame],eax

			mov eax,[framecount]
			cmp eax,[dwIndex]
			jne >.NODATA
				mov eax,[NextFrame]
				sub eax,[TopOfFrame]
				push eax

				mov edi,[TopOfFrame]
				add edi,[pMapFile]

				invoke memcopy, [pBuffer], edi, eax ;[cbFrame]
				pop eax
				mov [ReturnValue],eax
				jmp >>.EXIT
			.NODATA

			mov eax,[NextFrame]
			cmp eax, [TopOfFrame]
			je >
				mov [TopOfFrame],eax
				jmp >W2
			:
				mov eax, [cbTag]
				inc eax

		W2:
		inc D[framecount]
		cmp eax, [cbTag] 
		jle <<W1

	mov D[ReturnValue],-1
;	Close the file now that we're done

	.EXIT
	invoke UnmapViewOfFile,[pMapFile]
	invoke CloseHandle,[hMapFile]
	invoke CloseHandle,[hMP3File]

	mov eax,[ReturnValue]
	ret
ENDF

WriteV23Tag FRAME pFileName,pID3Info,fAllowUndo,fRemoveUnknown
	LOCAL pTag			:D
	LOCAL pBuffer		:D
	LOCAL cbFile		:D
	LOCAL cbTag			:D
	LOCAL dwSize		:D
	LOCAL ahead			:AUDIOHEADER
	LOCAL hTmpFile		:D
	LOCAL cbWritten		:D
	LOCAL TmpFile[260]	:B
	LOCAL DestPath[260]	:B
	LOCAL DestFile[64]	:B
	LOCAL SizeTag		:D

	invoke zeromem,offset DestPath,260
	invoke zeromem,offset TmpFile,260

	mov D[dwSize],10
	; Get the original tag size

	invoke openMP3,[pFileName],offset cbFile
	dec eax
	jns >
		mov eax,-1
		ret
	:

	invoke GetTagSize
	mov [cbTag],eax

	invoke UnmapViewOfFile,[pMapFile]
	invoke CloseHandle,[hMapFile]
	invoke CloseHandle,[hMP3File]

	; Worst case is original tag size + 4KB
	mov edi,[cbTag]
	add edi, 4192
	invoke GlobalAlloc,040h,edi
	mov [pBuffer],eax

	mov edi,[cbTag]
	add edi, 4192
	invoke GlobalAlloc,040h,edi
	mov [pTag],eax
	mov edi,eax
	mov D[edi],id3v3 ; ID3V2.3 signature
	add edi,10 ; reserve space for the header

	xor ebx,ebx
	inc ebx ; Start reading at frame 1

	cmp D[fRemoveUnknown],1
	je >>L2 ; do not write the unkown frames

	L1:
		invoke ID3GetFrameByIndex,[pFileName],ebx,[pBuffer]
		mov esi,eax
		or esi,esi
		js >>L2
		cmp esi,10
		je >>L2
		mov eax,[pBuffer]
		mov eax,[eax]
		cmp al,0
		je >>L2
			; make sure it's not one of the ones we are updating
			cmp eax,frame_TIT2
			je >
			cmp eax,frame_TALB
			je >
			cmp eax,frame_COMM
			je >
			cmp eax,frame_TPE1
			je >
			cmp eax,frame_TCON
			je >
			cmp eax,frame_TRCK
			je >
			cmp eax,frame_TYER
			je >
			cmp eax,frame_TCOP
			je >
			cmp eax,frame_TENC
			je >
			cmp eax,frame_WXXX
			je >
			cmp eax,frame_TCOM
			je >
			cmp eax,frame_TOPE
			je >
			add D[dwSize],esi

			invoke memcopy,edi,[pBuffer],esi
			add edi,esi
		:
		inc ebx
	jmp <<L1

	L2:
	; Done with the buffer
	invoke GlobalFree,[pBuffer]

	; Build new frames at the end of the buffer
	; EDI holds the current position in the output buffer
	mov esi,[pID3Info]

	; ################################

	lea ebx,[esi+ID3Info.idTIT2]
	invoke szLen,ebx
	or eax,eax
	jz >
	push eax
	mov D[edi+FRAMEHEADER.Sig],frame_TIT2
	inc eax
	invoke dw2SynchSafe,eax
	mov D[edi+FRAMEHEADER.Size],eax
	add edi,SIZEOF FRAMEHEADER+1
	invoke szCopy,edi,ebx
	pop eax
	add edi,eax
	:

	; ################################

	lea ebx,[esi+ID3Info.idTALB]
	invoke szLen,ebx
	or eax,eax
	jz >
	push eax
	inc eax
	invoke dw2SynchSafe,eax
	mov D[edi+FRAMEHEADER.Size],eax
	mov D[edi+FRAMEHEADER.Sig],frame_TALB

	add edi,SIZEOF FRAMEHEADER+1
	invoke szCopy,edi,ebx
	pop eax
	add edi,eax
	:

	; ################################

	lea ebx,[esi+ID3Info.idTPE1]
	invoke szLen,ebx
	or eax,eax
	jz >
	push eax
	inc eax
	invoke dw2SynchSafe,eax
	mov D[edi+FRAMEHEADER.Size],eax
	mov D[edi+FRAMEHEADER.Sig],frame_TPE1

	add edi,SIZEOF FRAMEHEADER+1
	invoke szCopy,edi,ebx
	pop eax
	add edi,eax
	:

	; ################################

	lea ebx,[esi+ID3Info.idTYER]
	invoke szLen,ebx
	or eax,eax
	jz >
	push eax
	inc eax
	invoke dw2SynchSafe,eax
	mov D[edi+FRAMEHEADER.Size],eax
	mov D[edi+FRAMEHEADER.Sig],frame_TYER

	add edi,SIZEOF FRAMEHEADER+1
	invoke szCopy,edi,ebx
	pop eax
	add edi,eax
	:

	; ################################

	lea ebx,[esi+ID3Info.idCOMM]
	invoke szLen,ebx
	or eax,eax
	jz >
	push eax
	add eax,5
	invoke dw2SynchSafe,eax
	mov D[edi+FRAMEHEADER.Size],eax
	mov D[edi+FRAMEHEADER.Sig],frame_COMM

	add edi,SIZEOF FRAMEHEADER+5
	invoke szCopy,edi,ebx
	pop eax
	add edi,eax
	:

	; ################################

	lea ebx,[esi+ID3Info.idTRCK]
	invoke szLen,ebx
	or eax,eax
	jz >
	push eax
	inc eax
	invoke dw2SynchSafe,eax
	mov D[edi+FRAMEHEADER.Size],eax
	mov D[edi+FRAMEHEADER.Sig],frame_TRCK

	add edi,SIZEOF FRAMEHEADER+1
	invoke szCopy,edi,ebx
	pop eax
	add edi,eax
	:

	; ################################

	lea ebx,[esi+ID3Info.idTCON]
	invoke szLen,ebx
	or eax,eax
	jz >
	push eax
	inc eax
	invoke dw2SynchSafe,eax
	mov D[edi+FRAMEHEADER.Size],eax
	mov D[edi+FRAMEHEADER.Sig],frame_TCON

	add edi,SIZEOF FRAMEHEADER+1
	invoke szCopy,edi,ebx
	pop eax
	add edi,eax
	:

	; ################################

	lea ebx,[esi+ID3Info.idTCOP]
	invoke szLen,ebx
	or eax,eax
	jz >
	push eax
	inc eax
	invoke dw2SynchSafe,eax
	mov D[edi+FRAMEHEADER.Size],eax
	mov D[edi+FRAMEHEADER.Sig],frame_TCOP

	add edi,SIZEOF FRAMEHEADER+1
	invoke szCopy,edi,ebx
	pop eax
	add edi,eax
	:

	; ################################

	lea ebx,[esi+ID3Info.idTENC]
	invoke szLen,ebx
	or eax,eax
	jz >
	push eax
	inc eax
	invoke dw2SynchSafe,eax
	mov D[edi+FRAMEHEADER.Size],eax
	mov D[edi+FRAMEHEADER.Sig],frame_TENC

	add edi,SIZEOF FRAMEHEADER+1
	invoke szCopy,edi,ebx
	pop eax
	add edi,eax
	:

	; ################################

	lea ebx,[esi+ID3Info.idURL]
	invoke szLen,ebx
	or eax,eax
	jz >
	push eax
	add eax,2
	invoke dw2SynchSafe,eax
	mov D[edi+FRAMEHEADER.Size],eax
	mov D[edi+FRAMEHEADER.Sig],frame_WXXX

	add edi,SIZEOF FRAMEHEADER+2
	invoke szCopy,edi,ebx
	pop eax
	add edi,eax
	:

	; ################################

	lea ebx,[esi+ID3Info.idTCOM]
	invoke szLen,ebx
	or eax,eax
	jz >
	push eax
	inc eax
	invoke dw2SynchSafe,eax
	mov D[edi+FRAMEHEADER.Size],eax
	mov D[edi+FRAMEHEADER.Sig],frame_TCOM

	add edi,SIZEOF FRAMEHEADER+1
	invoke szCopy,edi,ebx
	pop eax
	add edi,eax
	:

	; ################################

	lea ebx,[esi+ID3Info.idTOPE]
	invoke szLen,ebx
	or eax,eax
	jz >
	push eax
	inc eax
	invoke dw2SynchSafe,eax
	mov D[edi+FRAMEHEADER.Size],eax
	mov D[edi+FRAMEHEADER.Sig],frame_TOPE

	add edi,SIZEOF FRAMEHEADER+1
	invoke szCopy,edi,ebx
	pop eax
	add edi,eax
	:

	; ################################

	mov ebx,edi
	sub ebx,[pTag]
	mov [SizeTag],ebx

	; Align the tag size to the nearest 256 BYTE boundary
	add ebx,256
	and ebx,-255

	mov eax,ebx
	sub eax,10
	invoke dw2SynchSafe,eax
	mov edi,[pTag]
	mov [edi+6],eax

	; Find the start of the audio section
	
	invoke GetAudioInfo,[pFileName],offset ahead
	or eax,eax
	js >>.ERRORNOHANDLE
	
	invoke GetTempPathA,260,offset TmpFile
	invoke GetTempFileNameA,offset TmpFile,"zm_",0,offset TmpFile
	or eax,eax
	jz >>.ERRORNOHANDLE
	
	invoke DeleteFileA,offset TmpFile

	invoke CreateFileA,offset TmpFile,GENERIC_WRITE,0,0,CREATE_NEW,0,0
	mov [hTmpFile],eax
	or eax,eax
	js >>.ERRORNOHANDLE

	invoke SetLastError,0

	cmp D[SizeTag],10
	je >
		invoke WriteFile,[hTmpFile],[pTag],ebx,offset cbWritten,0
	:

	invoke openMP3,[pFileName],offset cbFile

	mov eax,[ahead.STRT]
	dec eax
	mov esi,eax
	add esi,[pMapFile]
	sub [cbFile],eax

	invoke WriteFile,[hTmpFile],esi,[cbFile],offset cbWritten,0

	invoke UnmapViewOfFile,[pMapFile]
	invoke CloseHandle,[hMapFile]
	invoke CloseHandle,[hMP3File]
	
	invoke CloseHandle,[hTmpFile]

	invoke GetLastError
	or eax,eax
	jnz >.ERRORNOHANDLE
	; The file was created without errors
	; So delete the original and move the tempfile in it's place

	; We need the fully qualified path the the destination
	invoke GetFullPathNameA,[pFileName],260,offset DestPath,offset DestFile
	invoke GetLongPathNameA,offset DestPath,offset DestPath,260

	invoke FileOp,offset DestPath,0,FO_DELETE,[fAllowUndo]
	or eax,eax
	jnz >.ERRORNOHANDLE
	invoke FileOp,offset TmpFile,offset DestPath,FO_MOVE,0

	.EXIT
	invoke GlobalFree,[pTag]
	xor eax,eax
	ret
	
	.ERRORNOHANDLE
	invoke GlobalFree,[pTag]
	xor eax,eax
	dec eax
	ret

ENDF
